//TODO: Item backgrounds, different one for faraway mayhaps?, test blackspace/whitespace edge cases,
// white lines for some boxes, copy and paste colored text from regular window back to all black window_battle

(function() {
	let old = Window_Base.prototype.resetFontSettings;
	Window_Base.prototype.resetFontSettings = function() {
		old.call(this);
		this.contents.outlineColor = 'rgba(0, 0, 0, 0)';
	}
})();

(function() {
	var whiteSpaceMaps = [0, 87, 308, 388];
	Window_Base.prototype.loadWindowskin = function() {
		if ($gameSwitches.value(7) === false && $gameSwitches.value(1574) === false 
			&& !whiteSpaceMaps.includes($gameVariables.value(9))) {
			this.windowskin = ImageManager.loadSystem('Window_Battle');
		}
		else
			this.windowskin = ImageManager.loadSystem('Window');
	}
})();

(function() {
	let old = Window_Message.prototype._refreshPauseSign;
	var whiteSpaceMaps = [0, 87, 308, 388];
	Window_Message.prototype._refreshPauseSign = function() {
		old.call(this);
		if ($gameSwitches.value(7) === false && $gameSwitches.value(1574) === false 
			&& !whiteSpaceMaps.includes($gameVariables.value(9))) {
			this._windowPauseSignSprite.bitmap = ImageManager.loadSystem('cursor_sheet');
			this._windowPauseSignSprite.move(this._width - 320, this._height - 10);
		}
	};
})();

(function() {
	let old = Window_Message.prototype._updatePauseSign;
	var whiteSpaceMaps = [0, 87, 308, 388];
	Window_Message.prototype._updatePauseSign = function() {
		old.call(this);
		if ($gameSwitches.value(7) === false && $gameSwitches.value(1574) === false 
			&& !whiteSpaceMaps.includes($gameVariables.value(9))) {
			this._windowPauseSignSprite.anchor.x = 0;
			this._windowPauseSignSprite.anchor.y = 0.5 + (Math.sin(this._animationCount * 0.1) * 0.1);
		}
	}
})();

(function() {
	var whiteSpaceMaps = [0, 87, 308, 388];
	DataManager.getItemIconGraphicsData = function(item) {
	  // If Item has Icon Graphics Data already set
	  if (item.meta.IconGraphicsData) { return item.meta.IconGraphicsData; };
	  // Initialize Data
	  var data = {name: '', index: 0, rows: 1, columns: 1};
	  // Set Item Icon Index
	  if (item.meta.IconIndex) { data.index = Number(item.meta.IconIndex); }
	  // Apply Properties to data
	  if (this.isKeyItem(item)) {
		if ($gameSwitches.value(7) === false && $gameSwitches.value(1574) === false 
			&& !whiteSpaceMaps.includes($gameVariables.value(9))) {
			data.name = 'itemImportantDW'; data.rows = 15, data.columns = 8;
		}
		else {
			data.name = 'itemImportant'; data.rows = 15, data.columns = 8;
		}
	  } else if (this.isConsumableItem(item)) {
		if ($gameSwitches.value(7) === false && $gameSwitches.value(1574) === false 
			&& !whiteSpaceMaps.includes($gameVariables.value(9))) {
			data.name = 'itemConsumablesDW'; data.rows = 12, data.columns = 8;
		}
		else {
			data.name = 'itemConsumables'; data.rows = 12, data.columns = 8;
		}
	  } else if (this.isToyItem(item)) {
		if ($gameSwitches.value(7) === false && $gameSwitches.value(1574) === false 
			&& !whiteSpaceMaps.includes($gameVariables.value(9))) {
			data.name = 'itemConsumablesDW'; data.rows = 12, data.columns = 8;
		} else {
			data.name = 'itemConsumables'; data.rows = 12, data.columns = 8;
		}
	  } else if (this.isWeapon(item)) {
		if ($gameSwitches.value(7) === false && $gameSwitches.value(1574) === false 
			&& !whiteSpaceMaps.includes($gameVariables.value(9))) {
			data.name = 'itemWeaponsDW'; data.rows = 5, data.columns = 9;
		} else {
			data.name = 'itemWeapons'; data.rows = 5, data.columns = 9;
		}
	  } else if (this.isArmor(item)) {
		if ($gameSwitches.value(7) === false && $gameSwitches.value(1574) === false 
			&& !whiteSpaceMaps.includes($gameVariables.value(9))) {
			data.name = 'itemCharmsDW'; data.rows = 13, data.columns = 7;
		} else {
			data.name = 'itemCharms'; data.rows = 13, data.columns = 7;
		}
	  };
	  // Set Item Icon Graphics Data
	  item.meta.IconGraphicsData = data;
	  // Get Item Icon Data
	  return data;
	}
})();

(function() {
	var whiteSpaceMaps = [0, 87, 308, 388];
	Scene_OmoriItemShop.prototype.initAtlastLists = function() {
	  // Run Original Function
	  Scene_BaseEX.prototype.initAtlastLists.call(this);
	  // Load System Images
	  if ($gameSwitches.value(7) === false && $gameSwitches.value(1574) === false 
			&& !whiteSpaceMaps.includes($gameVariables.value(9))) {
		  ImageManager.reserveSystem('itemConsumablesDW', 0,  this._imageReservationId)
		  ImageManager.reserveSystem('itemCharmsDW', 0,  this._imageReservationId)
		  ImageManager.reserveSystem('itemWeaponsDW', 0,  this._imageReservationId)
		  ImageManager.reserveSystem('ItemIcons1DW', 0,  this._imageReservationId)
		  ImageManager.reserveSystem('itemImportantDW', 0,  this._imageReservationId)
	  } else {
		  ImageManager.reserveSystem('itemConsumables', 0,  this._imageReservationId)
		  ImageManager.reserveSystem('itemCharms', 0,  this._imageReservationId)
		  ImageManager.reserveSystem('itemWeapons', 0,  this._imageReservationId)
		  ImageManager.reserveSystem('ItemIcons1', 0,  this._imageReservationId)
		  ImageManager.reserveSystem('itemImportant', 0,  this._imageReservationId)
	  }
	  ImageManager.reserveSystem('mailbox', 0, this._imageReservationId)
	  ImageManager.reserveSystem('mailboxLegend', 0, this._imageReservationId)
	}
})();